unit installpath;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Buttons, ExtCtrls;

type
  TPickFolder = class(TForm)
    PathEdit: TEdit;
    Image1: TImage;
    CaptionLabel: TLabel;
    procedure OK(Sender: TObject);
    procedure Cancel(Sender: TObject);
    procedure Browse(Sender: TObject);
  private
    function GetPath: String;
    procedure SetPath(const Value: String);
    function GetCaption: String;
    procedure SetCaption(const Value: String);
    { Private declarations }
  public
    { Public declarations }
    property Path: String read GetPath write SetPath;
    property Caption: String read GetCaption write SetCaption;
  end;

implementation
uses ActiveX, ShlObj;
{$R *.DFM}

procedure TPickFolder.OK(Sender: TObject);
begin
  ModalResult:=idOK;
end;

procedure TPickFolder.Cancel(Sender: TObject);
begin
  ModalResult:=idCancel;
end;

procedure TPickFolder.Browse(Sender: TObject);
var
  BrowseInfo: TBrowseInfo;
  IDList: PItemIDList;
  Malloc: IMalloc;
  SelectedPath: String;
begin
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  with BrowseInfo do
  begin
    hwndOwner:=Handle;
    lpszTitle:='Please select the folder in which you want to install this program:';
    ulFlags:=BIF_RETURNONLYFSDIRS;
  end;
  IDList:=SHBrowseForFolder(BrowseInfo);
  SetLength(SelectedPath, MAX_PATH);
  SHGetPathFromIDList(IDList, PChar(SelectedPath));
  SetLength(SelectedPath, StrLen(PChar(SelectedPath)));
  Path:=SelectedPath;

  ////Wot?? A COM object just to free the ID list?? I HATE Microsoft...oh well...
  if Succeeded(SHGetMalloc(Malloc)) then
    Malloc.Free(IDList);
end;

function TPickFolder.GetPath: String;
begin
  Result:=PathEdit.Text;
  if Result[Length(Result)] <> '\' then
    Result:=Result + '\';
end;

procedure TPickFolder.SetPath(const Value: String);
begin
  PathEdit.Text:=Value;
end;

function TPickFolder.GetCaption: String;
begin
  Result:=CaptionLabel.Caption;
end;

procedure TPickFolder.SetCaption(const Value: String);
begin
  CaptionLabel.Caption:=Value;
end;

end.
