unit ff8ini;

interface
uses IniFiles;

type
  TFF8IniFile = class(TIniFile)
  private
    function GetPath: String;
    function GetDataPath: String;
  public
    property Path: String read GetPath;
    property DataPath: String read GetDataPath;
  end;

implementation
uses Windows, Sysutils, Registry;
{ TFF8IniFile }


const
  FF8RegKey = '\Software\Square Soft, Inc\FINAL FANTASY VIII\1.00\';


var
  FF8Path: String; //This is common for all objects, saves a few clockcycles...

function TFF8IniFile.GetDataPath: String;
begin
  Result:=Path + 'data\music\dmusic\';
end;

function TFF8IniFile.GetPath: String;
begin
  if FF8Path = '' then
    with TRegistry.Create do
    try
      RootKey:=HKEY_LOCAL_MACHINE;
      if OpenKey(FF8RegKey, False) then
      begin
        FF8Path:=ReadString('AppPath');
        if (FF8Path <> '') and (FF8Path[Length(FF8Path)] <> '\') then
          FF8Path:=FF8Path + '\';
      end
      else
        FF8Path:=ParamStr(0);
    finally
      Free;
    end;
  Result:=FF8Path;
end;

end.
 