unit iDMLoader3;

interface

uses
  Windows, ActiveX, ComObj, DirectMusic, Registry;

type
  TIDMLoader = class(TComObject, IDirectMusicLoader)
  private
    FDirectMusicLoader: IDirectMusicLoader;
  protected
    function IDirectMusicLoader.GetObject = AGetObject;
    function GetObject(const pDesc: TDMus_ObjectDesc;
                        const riid : TGUID;
                        out ppv) : HResult; stdcall;
  public
    procedure Initialize; override;
    property DirectMusicLoader: IDirectMusicLoader read FDirectMusicLoader write
      FDirectMusicLoader implements IDirectMusicLoader;
  end;

const
//  Class_IDMLoader: TGUID = '{F6965061-0E47-11D4-8B12-706472C10000}';
  Class_IDMLoader: TGUID = '{D1AC2892-B39B-11D1-8704-00600893B1BD}';
// Class_IDMLoader2: TGUID = '{D3AC2892-B39B-11D1-8704-00600893B1BD}';
implementation

uses ComServ;

{ TTIDMLoader }

function TIDMLoader.GetObject(const pDesc: TDMus_ObjectDesc;
  const riid: TGUID; out ppv): HResult; assembler
var
  Desc: TDMus_ObjectDesc;
  FilenameChars : array [0..DMUS_MAX_FILENAME-1] of Char;
begin
  Desc:=pDesc;
  FillChar(Desc.wszFilename, SizeOf(Desc.wszFilename), 0);
  FileNameChars:='062s-bat3.sgt'#0;
  MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, @FilenameChars, -1, Desc.wszFilename, MAX_PATH);
  Result:=FDirectMusicLoader.GetObject(pDesc, riid, ppv);
end;

procedure TIDMLoader.Initialize;
begin
  CoCreateInstance(CLSID_DirectMusicLoader, nil, CLSCTX_INPROC,
    IID_IDirectMusicLoader, FDirectMusicLoader);
end;

initialization
  TComObjectFactory.Create(ComServer, TIDMLoader, Class_IDMLoader,
    'IDMLoader', '', ciMultiInstance, tmApartment);
end.
