unit inDirectMusic;

interface

uses
  Windows, ActiveX, ComObj, DirectMusic, DirectSound;


type
  IinDirectMusic = interface(IUnknown)
    ['{07EBA800-0E3F-11D4-8B12-706472C10000}']
    function EnumPort (dwIndex: DWORD;
                       var pPortCaps: TDMus_PortCaps) : HResult; stdcall;
    function CreateMusicBuffer (var pBufferDesc: TDMus_BufferDesc;
                                out ppBuffer: IDirectMusicBuffer;
                                pUnkOuter: IUnknown) : HResult; stdcall;
    function CreatePort (const rclsidPort: TGUID;
                         const pPortParams: TDMus_PortParams;
                         out ppPort: IDirectMusicPort;
                         pUnkOuter: IUnknown) : HResult; stdcall;
    function EnumMasterClock (dwIndex: DWORD;
                              var lpClockInfo: TDMus_ClockInfo) : HResult; stdcall;
    function GetMasterClock (pguidClock: PGUID;
                             ppReferenceClock : PIReferenceClock) : HResult; stdcall;
    function SetMasterClock (const rguidClock: TGUID) : HResult; stdcall;
    function Activate (fEnable: BOOL) : HResult; stdcall;
    function GetDefaultPort (out pguidPort: TGUID) : HResult; stdcall;
    function SetDirectSound (pDirectSound: IDirectSound;
                             hWnd: HWND) : HResult; stdcall;
  end;

  TTinDirectMusic = class(TComObject, IinDirectMusic)
  private
    FDirectMusic: IDirectMusic;
  protected
    constructor CreateFromFactory(Factory: TComObjectFactory;
      const Controller: IUnknown);
    function EnumPort (dwIndex: DWORD;
                       var pPortCaps: TDMus_PortCaps) : HResult; stdcall;
    function CreateMusicBuffer (var pBufferDesc: TDMus_BufferDesc;
                                out ppBuffer: IDirectMusicBuffer;
                                pUnkOuter: IUnknown) : HResult; stdcall;
    function CreatePort (const rclsidPort: TGUID;
                         const pPortParams: TDMus_PortParams;
                         out ppPort: IDirectMusicPort;
                         pUnkOuter: IUnknown) : HResult; stdcall;
    function EnumMasterClock (dwIndex: DWORD;
                              var lpClockInfo: TDMus_ClockInfo) : HResult; stdcall;
    function GetMasterClock (pguidClock: PGUID;
                             ppReferenceClock : PIReferenceClock) : HResult; stdcall;
    function SetMasterClock (const rguidClock: TGUID) : HResult; stdcall;
    function Activate (fEnable: BOOL) : HResult; stdcall;
    function GetDefaultPort (out pguidPort: TGUID) : HResult; stdcall;
    function SetDirectSound (pDirectSound: IDirectSound;
                             hWnd: HWND) : HResult; stdcall;
  end;

const
  Class_TinDirectMusic: TGUID = '{7B6CB1C0-0E3A-11D4-8B12-706472C10000}';

implementation

uses ComServ;

{ TTinDirectMusic }

constructor TTinDirectMusic.CreateFromFactory(Factory: TComObjectFactory;
  const Controller: IUnknown);
begin
  inherited CreateFromFactory(Factory, Controller);
  CoCreateInstance(CLSID_DirectMusic, nil, CLSCTX_INPROC,
    IID_IDirectMusic, FDirectMusic);
end;

function TTinDirectMusic.Activate(fEnable: BOOL): HResult;
begin
  Result:=FDirectMusic.Activate(fEnable);
end;

function TTinDirectMusic.CreateMusicBuffer(
  var pBufferDesc: TDMus_BufferDesc; out ppBuffer: IDirectMusicBuffer;
  pUnkOuter: IUnknown): HResult;
begin
  Result:=FDirectMusic.CreateMusicBuffer(pBufferDesc, ppBuffer, pUnkOuter);
end;

function TTinDirectMusic.CreatePort(const rclsidPort: TGUID;
  const pPortParams: TDMus_PortParams; out ppPort: IDirectMusicPort;
  pUnkOuter: IUnknown): HResult;
begin
  Result:=FDirectMusic.CreatePort(rclsidPort, pPortParams, ppPort, pUnkOuter);
end;

function TTinDirectMusic.EnumMasterClock(dwIndex: DWORD;
  var lpClockInfo: TDMus_ClockInfo): HResult;
begin
  Result:=FDirectMusic.EnumMasterClock(dwIndex, lpClockInfo);
end;

function TTinDirectMusic.EnumPort(dwIndex: DWORD;
  var pPortCaps: TDMus_PortCaps): HResult;
begin
  Result:=FDirectMusic.EnumPort(dwIndex, pPortCaps);
end;

function TTinDirectMusic.GetDefaultPort(out pguidPort: TGUID): HResult;
begin
  Result:=FDirectMusic.GetDefaultPort(pguidPort);
end;

function TTinDirectMusic.GetMasterClock(pguidClock: PGUID;
  ppReferenceClock: PIReferenceClock): HResult;
begin
  Result:=FDirectMusic.GetMasterClock(pguidClock, ppReferenceClock);
end;

function TTinDirectMusic.SetDirectSound(pDirectSound: IDirectSound;
  hWnd: HWND): HResult;
begin
  Result:=FDirectMusic.SetDirectSound(pDirectSound, hWnd);
end;

function TTinDirectMusic.SetMasterClock(const rguidClock: TGUID): HResult;
begin
  Result:=FDirectMusic.SetMasterClock(rguidClock);
end;

initialization
  TComObjectFactory.Create(ComServer, TTinDirectMusic, Class_TinDirectMusic,
    'TinDirectMusic', '', ciMultiInstance, tmApartment);
end.

